/*	This file is part of cfgd
**
**	Copyright 2002 Oliver Schroeder
**	
**	Permission to use,  copy, modify, and distribute this
**	software  and its  documentation  for any purpose and
**	without any fee is  hereby granted, provided that the
**	above  copyright notice  and  this  permission notice
**	appear in  all copies of the  software and derivative
**	works or modified versions thereof, and that both the
**	copyright notice and  this permission  and disclaimer
**	notice appear in supporting documentation.
**	
**	This software is provided "as is" WITHOUT ANY WARRANTY.
**	
**	Oliver Schroeder <post@o-schroeder.de>
*/

#ifndef CLIST_HEADER
#define CLIST_HEADER

#include <pthread.h>

typedef struct st_ListNode
{
	void*   vp_Content;
	struct  st_ListNode* p_Next;
	struct  st_ListNode* p_Prev;
} t_ListNode;

typedef struct st_List
{
	struct  st_ListNode*	p_Current;
	struct  st_ListNode*	p_Top;
	struct  st_ListNode*	p_Bottom;
	pthread_mutex_t		MyMutex;
} t_List;

t_List*		ListCreate	();
int		ListSetStart	( t_List* p_List );
int		ListSetEnd	( t_List* p_List );
int		ListPushFront	( t_List* p_List, void* vp_Content );
int		ListPushBack	( t_List* p_List, void* vp_Content );
void*		ListPopFront	( t_List* p_List );
void*		ListPopBack	( t_List* p_List );
void*		ListTop		( t_List* p_List );
void*		ListCurrent	( t_List* p_List );
void*		ListNext	( t_List* p_List );
void*		ListPrev	( t_List* p_List );
int		ListEmpty	( t_List* p_List );
void		ListDestroy	( t_List* p_List );

#endif
