/*
**	This file is part of cfgd
**
**      Copyright 2002 Oliver Schroeder
**
**      Permission to use, copy, modify, and distribute this
**      software and its documentation for any purpose and
**      without any fee is hereby granted, provided that the
**      above copyright notice and this permission notice
**      appear in all copies of the software and derivative
**      works or modified versions thereof, and that both the
**      copyright notice and this permission and disclaimer
**      notice appear in supporting documentation.
**
**      This software is provided "as is" WITHOUT ANY WARRANTY.
**
**      Oliver Schroeder <post@o-schroeder.de>
**
*/

#ifndef CFGSTACK_HEADER
#define CFGSTACK_HEADER

typedef struct st_CfgStack
{
	void*	vp_Content;
	struct	st_CfgStack* p_Top;
	struct	st_CfgStack* p_Next;
	struct	st_CfgStack* p_Current;
} t_CfgStack;

t_CfgStack* CfgStack_Create ();
int   CfgStack_Push ( t_CfgStack* p_Stack, void* vp_Content );
void* CfgStack_Pop ( t_CfgStack* p_Stack );
void* CfgStack_Top ( t_CfgStack* p_Stack );
int   CfgStack_Empty ( t_CfgStack* p_Stack );

void  CfgStack_SetStart ( t_CfgStack* p_Stack );
void* CfgStack_Next ( t_CfgStack* p_Stack );

void  CfgStack_Destroy ( t_CfgStack* p_Stack );

#endif
